/* ************************************************************************
 *
 * CookieKeeper - a Mozilla add-on
 * (c) 2015 Yvon TANGUY
 *
 * ***** BEGIN LICENSE BLOCK **********************************************
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * ***** END LICENSE BLOCK **********************************************
 *
 * Local shared object (LSOs) / Flash cookies viewer.
 *
 * ************************************************************************
 */

"use strict";

var gLocalSharedObjectEditor = {

  init: function() {
    if (window.arguments == null) {
      log.e("gLocalSharedObjectEditor: no arguments");
      window.close();
      return;
    }

    let item = window.arguments.length >= 1 ? window.arguments[0] : null;
    if (item == null || item.getType() != COOKIE_TYPE_LSO) {
      log.e("gLocalSharedObjectEditor: invalid arguments");
      window.close();
      return;
    }

    let bundle      = document.getElementById("bundleCookieKeeper");
    let tbHostView  = document.getElementById("tbHostView");
    let tbName      = document.getElementById("tbName");
    let tbContent   = document.getElementById("tbContent");
    let labelSize   = document.getElementById("labelSize");
    let tbJsonError = document.getElementById("tbJsonError");

    let hostText = item.getHost();
    if (gCommon.isSpecialHost(hostText)) {
      hostText = bundle.getString(hostText.substring(1, hostText.length-1));
    }

    tbHostView.value = hostText;
    tbName.value     = item.getName();

    try {
      let json = JSON.parse(item.value);
      let jsonText = JSON.stringify(json, null, 2);
      tbContent.value = jsonText;
      labelSize.value = gCommon.getHumanSize(item.fileSize, bundle);
    } catch (ex) {
      tbJsonError.value = ex.toString();
      log.e(ex);
    }
  },

  uninit: function() {

  },

  onWindowKeyPress: function(aEvent) {
    if (aEvent.keyCode == KeyEvent.DOM_VK_ESCAPE) {
      window.close();
    }
  }
}
